#!/usr/bin/perl

####################################################################
#                                                                  #
#               Logged Redirector                                  #
#               Kastle Internet Services                           #
#               http://www.kastle.net                              #
#               kastle@kastle.net                                  #
#                                                                  #
####################################################################
#                                                                  $
#  THIS PROGRAM MAY BE USED AND DISTRIBUTED FREELY PROVIDED        #
#  NO MODIFICATIONS ARE MADE TO THE CODE.                          #
#                                                                  #
#  Copyright (c) 1998 - Kastle Internet Services                   #
#  All rights reserved                                             #
#  Written & Tested by Kastle Internet Services                    #
#  gatekeeper@kastle.net                                           #
#                                                                  #
#                                                                  #
####################################################################
#  DISCLAIMER:                                                     #
#                                                                  #
#  In no event will Kastle Internet Services be liable to the user #
#  of this script or any third party for any damages, including    #
#  any lost profits, lost savings or other incidental,             #
#  consequential or special damages arising out of the operation   #
#  of or inability to operate this script, even if user has been   #
#  advised of the possibility of such damages.                     #
#                                                                  #
####################################################################

require "log_redirect.conf";

#########################################
#      DO NOT EDIT BELOW THIS LINE      #
#########################################

   $shortdate = `date +"%D %T %Z"`;
   chop($shortdate);


  $url = $ENV{'QUERY_STRING'}; 
 
  &read_counts;
  &update_counts;
  &write_counts;

  print "Location: $url\n\n";


  exit;

################################################

sub update_counts{

  $found = 0; 
  for ($x=1;$x <= $numurls;$x++) {
    if ($urls[$x] =~ $url) {
      $counts[$x]++;  #increment the # of hits
      $found = 1;
    }      
   }
  if ($found == 0) {
   $numurls++;
   $urls[$numurls] = $url;
   $counts[$numurls] = 1;
  }
}

sub read_counts {
    $numurls = 0;
    &open_file("FILE1","",$counter_data);
    while ($line = &read_file("FILE1"))  {
      $numurls++;
      ($urls[$numurls], $counts[$numurls]) = split(/\s*\|\s*/,$line ,2);  
      chop($counts[$numurls]);
    }
    close(FILE1);
}

sub write_counts {

    &open_file("FILE1",">",$counter_data);
    for ($x=1;$x <= $numurls;$x++) {
      &write_file("FILE1",$urls[$x] . "|" . $counts[$x] . "\n"); 
    }   
    close(FILE1);
}

sub open_file {

  local ($filevar, $filemode, $URL_data) = @_;
  
  open ($filevar,$filemode . $URL_data) ||
     die ("Can't open $URL_data");
}

sub read_file {

  local ($filevar) = @_;

  <$filevar>;  
}

sub write_file {

  local ($filevar, $line) = @_;

  print $filevar ($line);
}
